/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.internal.backend;

import java.util.Random;

import edu.washington.cs.vanish.util.Initializable;
/**
 * 
 * For an implementation of this interface to be loadable through the
 * VanishXMLRPCServer using the DefaultVanishFactory, it must provide a
 * two-parameter constructor: (VanishConfiguration conf, VanishLogger log). 
 * 
 * The interface to the backend is currently synchronous, which is extremely
 * bad from a scalability standpoint, but easier to deal with.
 *  TODO(roxana): Change to asynchronous mode.
 * @author roxana
 */
public interface VanishBackendInterface extends Initializable {	
	public byte[] generateLocation(Random prg);
	
	public byte[][] getShares(byte[][] locations, int threshold)
	throws VanishBackendException, TooManySharesLostVanishException;
	
	public void pushShares(byte[][] shares, byte[][] locations)
	throws VanishBackendException;
	
	public String getIdentifier();
}
