/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.internal.impl;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.Vector;

/**
 * TODO(roxana): Move to util or IO.
 * @author roxana
 */
public class InputStreamWrapper extends InputStream {
	private ObjectInputStream object_is;
	Vector<InputStream> spawned_is;
	
	public InputStreamWrapper(InputStream other) {
		spawned_is = new Vector<InputStream>();
		addStreamForClosing(other);
	}
	
	@Override
	public int read() throws IOException { return getTopStream().read(); }
	
	@Override
	public void close() throws IOException {
		for (InputStream is: spawned_is) is.close();
		if (object_is != null) object_is.close();
	}
	
	public ObjectInputStream getObjectInputStream() throws IOException {
		if (object_is == null) {
			object_is = new ObjectInputStream(getTopStream());
		}
		return object_is;
	}
	
	public void addStreamForClosing(InputStream is) {
		if (is != null) spawned_is.add(0, is);
	}
	
	public InputStream getTopStream() {
		return spawned_is.isEmpty() ? null : spawned_is.get(0);
	}
	
	public InputStream getBaseStream() {
		return spawned_is.isEmpty()
				? null : spawned_is.get(spawned_is.size() - 1);
	}
}

