/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.internal.impl;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.util.Vector;
import java.util.zip.GZIPOutputStream;
/**
 * TODO(roxana): Move to util or IO.
 * @author roxana
 */
public class OutputStreamWrapper extends OutputStream {
	private ObjectOutputStream object_is;
	Vector<OutputStream> spawned_is;
	
	public OutputStreamWrapper(OutputStream other) {
		spawned_is = new Vector<OutputStream>();
		addStreamForClosing(other);
	}
	
	@Override
	public void write(int x) throws IOException { getTopStream().write(x); }
	
	@Override
	public void close() throws IOException {
		for (OutputStream os: spawned_is) {
			if (os instanceof GZIPOutputStream) {
				((GZIPOutputStream)os).finish();
			}
			os.flush();
			os.close();
		}
		if (object_is != null) object_is.close();
	}
	
	public ObjectOutputStream getObjectOutputStream() throws IOException {
		if (object_is == null) {
			object_is = new ObjectOutputStream(getTopStream());
		}
		return object_is;
	}
	
	public void addStreamForClosing(OutputStream is) {
		if (is != null) spawned_is.add(0, is);
	}

	public OutputStream getTopStream() {
		return spawned_is.isEmpty() ? null : spawned_is.get(0);
	}
	
	public OutputStream getBaseStream() {
		return spawned_is.isEmpty()
				? null : spawned_is.get(spawned_is.size() - 1);
	}
}
