/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.internal.metadata.impl;

import edu.washington.cs.vanish.internal.metadata.Metadata;
import edu.washington.cs.vanish.internal.metadata.VDOParams;
/**
 * 
 * @author roxana
 *
 */
public class BasicMetadataImpl implements Metadata {
	private static final long serialVersionUID = -2876321005520007721L;

	private final VDOParams params;
	
	private final long location_seed;
	
	public BasicMetadataImpl(VDOParams params, long location_seed) {
		this.params = params;
		this.location_seed = location_seed;
	}

	// Metadata interface: 

	public long[] getAllPossibleLocationSeeds() {
		return new long[] { location_seed };
	}

	public long getLocationSeed() { return location_seed; }

	public VDOParams getVDOParams() { return params; }
	
	// Object interface:
	
	@Override
	public String toString() {
		return params == null ? "null" : params.toString();
	}
	
	@Override
	public boolean equals(Object other) {
		if (other == null) return false;
		if (this == other) return true;
		if (! (other instanceof BasicMetadataImpl)) return false;
		BasicMetadataImpl o = (BasicMetadataImpl)other;
		return (location_seed == o.location_seed &&
		        (params == o.params ||
		         (params != null && params.equals(o.params))));
	}
	
	@Override
	public int hashCode() {
		int hash = 7;
		hash = hash * 31 + (int)location_seed;
		hash = hash * 31 + (params == null ? 0 : params.hashCode());
		return hash;
	}
}
