/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.service;

import java.util.Map;

import edu.washington.cs.vanish.internal.VanishException;
/**
 * 
 * @author roxana
 *
 */
public interface LocalVanishServiceInterface extends VanishServiceInterface {
	public static final String kVanishServiceName = "LocalVanish";
	
	// Return types are ints ONLY for compatibility with Apache's RPC server.
	public int encapsulate(Map<String, Object> caller_params,
			               String input, String output,
			               Map<String, Object> vdo_params)
	throws VanishException;

	public int decapsulate(Map<String, Object> caller_params,
			               String input, String output)
	throws VanishException;

	public int refreshReadOnly(Map<String, Object> caller_params, String input)
	throws VanishException;

	public int refreshDeeply(Map<String, Object> caller_params,
			                 String input, String output,
			                 Map<String, Object> vdo_params)
	throws VanishException;
}
