/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.service;

import java.util.Map;

import edu.washington.cs.vanish.internal.VanishException;
/**
 * 
 * @author roxana
 *
 */
public interface RemoteVanishServiceInterface extends VanishServiceInterface {
	public static final String kVanishServiceName = "RemoteVanish";

	public byte[] decapsulate(Map<String, Object> caller_params, byte[] input)
	throws VanishException;

	/**
	 * int returned only to be compatible w/ Apache's XML RPC server.
	 * Do not use the value.
	 */
	public int refreshReadOnly(Map<String, Object> caller_params, byte[] input)
	throws VanishException;

	public byte[] refreshDeeply(Map<String, Object> caller_params,
			                    byte[] input, Map<String, Object> vdoParams)
    throws VanishException;

	byte[] encapsulate(Map<String, Object> caller_params, byte[] input,
			           Map<String, Object> vdoParams)
	throws VanishException;
}
