/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.stats;

import edu.washington.cs.vanish.service.impl.IllegalServerStateVanishException;
import edu.washington.cs.vanish.util.Initializable;

/**
 * 
 * @author roxana
 */
public interface StatsCollector extends Initializable {
	public static enum ReportLevel {
		NONE,
		INSENSITIVE,
		SENSITIVE     // includes insensitive
	}

	public void report(Stat stat) throws IllegalServerStateVanishException;
	public void report(Stat stat, Throwable t)
	throws IllegalServerStateVanishException;

	public ReportLevel getCurrentReportLevel();
}
