/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.stats.impl;

import java.util.HashMap;
import java.util.Map;

import edu.washington.cs.vanish.stats.Stat;
import edu.washington.cs.vanish.stats.StatsCollector.ReportLevel;
/**
 * 
 * @author roxana
 *
 */
@SuppressWarnings({ "serial", "unchecked" })
public class MultiValueStat implements Stat {
	protected Map<String, Object> map[];
	
	public MultiValueStat() {
		map = new Map[ReportLevel.values().length];
		for (int i = 0; i < map.length; ++i) {
			map[i] = new HashMap<String, Object>();
		}
	}
	
	// @Override
	public String checkpoint(ReportLevel level) {
		StringBuffer value = new StringBuffer();
		for (int i = 0; i <= level.ordinal(); ++i) {
			for(Map.Entry<String, Object> e: map[i].entrySet()) {
				value.append(e.getKey());
				value.append("=");
				value.append(e.getValue());
				value.append(";");
			}
		}
		return value.toString();
	}
	
	public void addStatPiece(ReportLevel level, String name, Object value) {
		map[level.ordinal()].put(name, value);
	}
}
