/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.system;

import edu.washington.cs.vanish.internal.VanishException;

/**
 * Interface for factory of Vanish cores.
 * 
 * All VanishFactories passed to a server must have a constructor with
 * parameter VanishServerParams for dynamic loading.
 * 
 * @author roxana
 */
public interface VanishFactory {
	public VanishInterface getInitializedVanishSystem() throws VanishException;
}
