/*
 * This code is subject to an academic license contained in the LICENSE-vanish.txt
 * file that can be found in the root directory of Vanish.
 */

package edu.washington.cs.vanish.system;

import java.io.InputStream;
import java.io.OutputStream;

import edu.washington.cs.vanish.internal.VanishException;
import edu.washington.cs.vanish.internal.impl.InputStreamWrapper;
import edu.washington.cs.vanish.internal.impl.OutputStreamWrapper;
import edu.washington.cs.vanish.internal.metadata.Metadata;
import edu.washington.cs.vanish.internal.metadata.VDOParams;
import edu.washington.cs.vanish.util.Initializable;
/**
 * 
 * @author roxana
 *
 */
public interface VanishInterface extends Initializable {
	public Metadata encapsulate(InputStream clear_data_is,
			                    OutputStreamWrapper enc_data_os,
                                VDOParams params)
	throws VanishException;
	
	/**
	 * 
	 * @param enc_data_is
	 * @param clear_data_os
	 * @return metadata
	 * @throws VanishException
	 */
	public Metadata decapsulate(InputStreamWrapper enc_data_is,
                                OutputStream clear_data_os)
	throws VanishException;

	public void refreshReadOnly(Metadata metadata) throws VanishException;
	
	public Metadata refreshDeeply(InputStreamWrapper enc_data_is,
                                  OutputStreamWrapper refreshed_enc_data_os,
                                  VDOParams params)
	throws VanishException;
}
